//=============================================================================
// (c) Copyright 2014 Diamond Systems Corporation. Use of this source code
// is subject to the terms of Diamond Systems' Software License Agreement.
// Diamond Systems provides no warranty of proper performance if this
// source code is modified.
//
// File: JNMM4LPXTDIOFunctions.c  v1.00
//
// Dependency :	
//				Exportheader.H ,Public.h- Include file.
//				
//				dsccan.dll	- Library file for windows 32-bit OS
//						
//				dsccan.LIB	- library file for Windows 
//						( USE VC++ 8.0 or Visual Studio 2008)
//				 
// Description: This demo application shows how to configure DIO ports in input and output mode 
//				then read and write to the DIO ports.
//============================================================================

#include "stdafx.h"

#include "exportHeader.h"

#define ISA_MODE 1

#define READ_BYTE 1

#define WRITE_BYTE 2

void readBytePort();

void writeBytePort();

int flag=0; // Flag 0 PCI ,Flag 1 ISA

unsigned int base_address = 0x7000;
unsigned int diobase_address = 0x340;


#define INVALID_HANDLE_VALUE ((HANDLE)(LONG_PTR)-1)

int main()
{
	int device=0;
	char input_buffer[20];
	char dio_buffer[20];
	HANDLE device_handle;
	int intBuff = 0; // temp variables of size int
	int temp = 0; // temporary storage
	
	printf ("JNMM-4LP-XT DIO Demo Application \n\n" );
	
	
	
	device_handle = JNMMCANOpen(&flag);
	if (device_handle == INVALID_HANDLE_VALUE)
	{
		return 0;
	}
	   
	if(flag == ISA_MODE ) // ISA device 	
	{
		printf("JNMM-4LP-XT-ISA device opened \n");
		printf ( "Enter the base address ( 0xE000,0x1000,0x2000,0x3000,0x4000,0x5000,0x6000,default 0x7000  , hit ENTER ) : " );
		fgets ( input_buffer, 20, stdin );

		if ( input_buffer[0] == '\n' )
		{
			printf("base address default with 0x7000  \n");
		}
		else
		{
			sscanf( input_buffer, "%x", &base_address );
		}
		JNMMCANBaseAddrInit(base_address);

		printf("Enter the DIObase address (0x0100,0x0140,0x0180,0x01C0,0x0200,0x0240,0x0300,default= 0x0340 , hit ENTER) : ");
		fgets(dio_buffer, 20, stdin);

		if (dio_buffer[0] == '\n')
		{
			printf("DIOBase address default with 0x0340  \n");
		}
		else
		{
			sscanf(dio_buffer, "%x", &diobase_address);
		}
		JNMMCANDIOAddrInit(diobase_address);
		
	}
	else
		printf("JNMM-4LP-XT-PCI device opened \n");
		
	//		JNMMCAN Port for Read AND Write 
	
	//
	//		Guide:
	//
	//		1. Read a Byte from CAN port 
	//		2. Write a Byte to CAN port
	//		q. Quit Program
	// 		Choose these options in any order from the menu!
	//=========================================================================
	printf( "\nJNMM Read and write a byte: Main Menu \n" );

	do
	{
		intBuff = 0;
		printf (  "########################################################\n" );
		printf (  "1) Read a Byte from CAN port \n" );
		printf (  "2) Write a Byte to CAN port\n" );
		printf (  "q) Quit Program \n" );
		printf (  "########################################################\n" );
		
	fgets ( input_buffer, 20, stdin );
        sscanf ( input_buffer, "%d", &intBuff );
        if ( input_buffer[0] == 'q' )
        {
            intBuff = 'q';
        }
		switch ( intBuff )
		{

			case READ_BYTE:
				readBytePort();
				break;

			case WRITE_BYTE:
				writeBytePort();
				break;
			case 'q':
					return 0;
            		break;

				default: // invalid option selected
					printf("Please Enter valid option \r\n");
					break;
		}
	}while ( input_buffer[0] != 'q' );


	JNMMCANClose(device_handle);
	return 0;
}

//=============================================================================
// Name: readByteDIOPort()
// Desc: Read a CAN port (0-3) by receiving a byte from the selected port's  register.
// Parameters:void
// Return: void
//=============================================================================
void readBytePort()
{
	unsigned char offset;
	int port = 0;
	int input_byte = 0; 
	char input_buffer[20];
	char output_buffer[20];
        unsigned char data =0;
	

	printf ("Enter CAN port number (0-3):");
	fgets ( input_buffer, 20, stdin );
   	sscanf ( input_buffer, "%d", &port );
	
	printf ("Enter the Offset to read from the CAN port %d (HEX):  ",port);
	fgets ( output_buffer, 20, stdin );
   	sscanf ( output_buffer, "%x", &offset );

	data = JNMMCANRead ( port,offset);
		
	printf("Byte value received from port %d = 0x%x\r\n", port, data);
	return;
}


//=============================================================================
// Name: writeBytePort()
// Desc: Program a CAN port (0-3) by sending a byte to the selected port's
//	  register.
// Parameters: void
// Return: void
//=============================================================================
void writeBytePort()
{
	unsigned char offset;
	int port = 0;
	char input_buffer[20];
	char output_buffer[20];
	unsigned char output_byte = 0;
	unsigned char intBuff = 0;

	printf ("Enter port number (0-3):");
	fgets ( input_buffer, 20, stdin );
   	sscanf ( input_buffer, "%d", &port );

	printf ("Enter the Offset to read from the CAN port %d (HEX):  ",port);
	fgets ( output_buffer, 20, stdin );
   	sscanf ( output_buffer, "%x", &offset );
	
	printf("Enter HEX value to the CAN Port  or q to quit:");
	fgets ( input_buffer, 20, stdin );
	sscanf ( input_buffer, "%x", &intBuff );
		
	if ( input_buffer[0] == 'q' )
	{
		intBuff = 'q';
	}
	else
	{
		output_byte = (BYTE)intBuff;
		
		JNMMCANWrite(port,offset,output_byte);
		printf("The Byte value  %x is sent to port %d \n",output_byte,port);
	}
	
	return;
}

